﻿using System.Reflection;

using Microsoft.Maui.Graphics.Platform;

namespace TestProject;

/// <summary>
/// 그래픽스 그리기 가능형
/// </summary>
public class GraphicsDrawable : IDrawable
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 그리기 - Draw(canvas, dirtyRectangle)

    /// <summary>
    /// 그리기
    /// </summary>
    /// <param name="canvas">캔버스</param>
    /// <param name="dirtyRectangle">더티 사각형</param>
    public void Draw(ICanvas canvas, RectF dirtyRectangle)
    {
        canvas.FillColor = Colors.Yellow;

        canvas.FillRectangle(dirtyRectangle);

        Assembly assembly = GetType().GetTypeInfo().Assembly;

        using(Stream stream = assembly.GetManifestResourceStream("TestProject.IMAGE.sample.jpg"))
        {
            Microsoft.Maui.Graphics.IImage image = PlatformImage.FromStream(stream);

            float width;
            float height;
            float offset;

            if(image.Width > image.Height)
            {
                width  = 250;
                height = 250 * image.Height / image.Width;
                offset = (width - height) / 2;

                canvas.DrawImage(image, 50, 50 + offset, width, height);
            }
            else
            {
                height = 250;
                width  = 250 * image.Width / image.Height;
                offset = height - width;

                canvas.DrawImage(image, 50 + offset, 50, width, height);
            }
        }
    }

    #endregion
}